#!/usr/bin/perl
 
########################################################################
# COPYRIGHT NOTICE:
#
# Copyright 2003 FocalMedia.Net All Rights Reserved.
#
# Selling the code for this program without prior written consent 
# from FocalMedia.Net is expressly forbidden. You may not 
# redistribute this program in any shape or form.
# 
# This program is distributed "as is" and without warranty of any
# kind, either express or implied. In no event shall the liability 
# of FocalMedia.Net for any damages, losses and/or causes of action 
# exceed the total amount paid by the user for this software.
#
########################################################################

#### EDIT HERE -- FOR WINDOWS/IIS BASED INSTALLATIONS ONLY #######

$config_cgi = "../config.cgi"; ## <-- CHANGE THIS LINE TO THE FULL SERVER PATH TO config.cgi

$version = "FM EasyList ver 2.2";

# THE PATH ON A WINDOWS INSTALLATION WILL LOOK SOMETHING LIKE THIS:
# $config_cgi = "c:/inetpub/webpub/cgi-bin/pseek/config.cgi";

#### DO NOT CHANGE ANYTHING BELOW THIS LINE #################

#use FindBin;
#use lib $FindBin::Bin;
use CGI;
use easylist;

&get_setup;
$q = CGI->new;

easylist::check_access($username, $password, $q->param('username'), $q->param('password'));

$thetime = time();
($sec,$min,$hour,$mday,$mon,$year,$wday,$ydat,$isdst) = localtime($thetime);
$year = "20" . substr($year, 1, 2);

$template = easylist::get_file_contents("$data_dir/controlpanel.html");

$template =~ s/!!webdir!!/$webdir/gi;
$template =~ s/!!version!!/$version /gi;
$template =~ s/!!year!!/$year/gi;

$template =~ s/!!home!!/$script_url\/admin.cgi/gi;
$template =~ s/!!get_code!!/$script_url\/admin.cgi?fct=getcode/gi;
$template =~ s/!!templates!!/$script_url\/admin.cgi?fct=templates/gi;
$template =~ s/!!email_manage!!/$script_url\/admin.cgi?fct=email_manage/gi;
$template =~ s/!!send_email!!/$script_url\/admin2.cgi/gi;


##################################################################################

print "Content-type: text/html\n\n";


#####
if ($q->param('fct') eq "") {&start;}
if ($q->param('fct') eq "add_email") {&add_email;}
if ($q->param('fct') eq "add_email_final") {&add_email_final;}
if ($q->param('fct') eq "edit_email") {&edit_email;}
if ($q->param('fct') eq "save_email_final") {&save_email_final;}
if ($q->param('fct') eq "del_email") {&del_email;}
if ($q->param('fct') eq "send_email") {&send_email;}

if ($q->param('fct') eq "create_email_type") {&create_email_type;}




#####

sub create_email_type
{

if ($q->param('email_type') eq "plain") { &add_email; }
if ($q->param('email_type') eq "HTML") { &add_email_HTML; }


}



sub add_email_HTML
{


$tmplc = qq[

<table>
  <tr>
    <td vAlign="top" width="1%"><font face="Verdana" size="1"><img src="$webdir/ic_email1.gif"></font></td>
    <td vAlign="top" width="99%"><font face="Arial" color="#000000" size="4"><strong>Compose 
    Email<br>
    </strong></font><font face="Arial" size="2">Type your email message below and choose 
    'Create Email Message'. You will be able to send out the email message to subscribers 
    after the it has been composed/created.</font></td>
  </tr>
</table>

<hr size="1" color="#E5E5E5">

<form method="POST" action="$script_url/admin2.cgi">
  <input type="hidden" name="fct" value="add_email_final">
  <input type="hidden" name="htmlemail" value="true">
  <table bgColor="#C0C0C0"
  border="0" cellPadding="3" cellSpacing="1" width="100%">
    <tr>
      <td bgColor="#FFE135" colSpan="2" height="30" width="100%" background="$webdir/bar.gif"><font
      face="Arial" size="2"><strong>Email Messages</strong></font></td>
    </tr>
    <tr>
      <td bgColor="#FFFFFF" width="21%" height="30"><font face="Arial" size="2">Description of 
      this message:</font></td>
      <td bgColor="#FFFFFF" width="61%" height="30"><font face="Arial" size="2"><input
      type="text" name="ename" size="45"><br>
      (Enter a descriptive name for this email message)</font></td>
    </tr>
    <tr>
      <td bgColor="#FFFFFF" width="21%" height="30"><font face="Arial" size="2">From Email 
      Address:</font></td>
      <td bgColor="#FFFFFF" width="61%" height="30"><font face="Arial" size="2"><input
      type="text" name="from_email" size="45"> </font></td>
    </tr>
    <tr>
      <td bgColor="#FFFFFF" width="21%" height="30"><font face="Arial" size="2">From Name:</font></td>
      <td bgColor="#FFFFFF" width="61%" height="30"><font face="Arial" size="2"><input
      type="text" name="from_name" size="45"> </font></td>
    </tr>
    <tr>
      <td bgColor="#FFFFFF" width="21%" height="30"><font face="Arial" size="2">Email Subject:</font></td>
      <td bgColor="#FFFFFF" width="61%" height="30"><font face="Arial" size="2"><input
      type="text" name="subject" size="54"></font></td>
    </tr>
    <tr>
      <td bgColor="#FFFFFF" colspan="2" align="center">

<textarea id="txtContent" name="msg" rows="100" cols="50">

</textarea> <script>
		var oEdit1 = new InnovaEditor("oEdit1");
		oEdit1.width="100%";
		oEdit1.height="650px";
		oEdit1.mode="HTMLBody";
		oEdit1.REPLACE("txtContent");
</script> 




</td>
    </tr>
    <tr>
      <td bgColor="#FFFFFF" colspan="2"><div align="center"><center><p><input type="submit"
      value="Create Email Message" name="B1"></td>
    </tr>
  </table>
</form>


<div align="center"><center>

<table border="0" cellpadding="10" cellspacing="0" width="100%">
  <tr>
    <td width="100%"><font face="Arial" size="2"><strong>Notes:</strong></font><ul>
      <li><span style="line-height: 20px"><font face="Arial" size="2">Click the <strong>&lt;&gt;</strong>
        icon in the top menu bar of the Wysiwyg editor to view the source of the page or to copy and
        paste HTML code from a web editor into this web editor.</font></span></li>
      <li><span style="line-height: 20px"><font face="Arial" size="2">We have gone to great
        lengths to ensure the successful sending of HTML email but note that most email programs
        won't interpret HTML email the same.</font></span></li>
      <li><span style="line-height: 20px"><font face="Arial" size="2">The most reliable way to
        send email to subscribers to ensure that they are successfully receiving it is to use
        plain text email.</font></span></li>
    </ul>
    <p><span style="line-height: 20px"><font face="Arial" size="2"><strong>HTML Design Email
    Guidelines:</strong></font></span><ul>
      <li><span style="line-height: 20px"><font face="Arial" size="2">Send yourself a test message
        to get a preview of how the HTML email will arrive at subscribers. This can be done from
        the 'Send Email' tab.</font></span></li>
      <li><span style="line-height: 20px"><font face="Arial" size="2">It is very important that
        you keep your HTML email simple due to Email readers not interpreting all HTML email
        equally. It would be necessary that you test the HTML message with Outlook 2003, Outlook
        2000, Outlook Express, Eudora, Mozilla Thunderbird, AOL, Yahoo Mail, Google's Gmail,
        Hotmail, etc.</font></span></li>
      <li><span style="line-height: 20px"><font face="Arial" size="2">All images used need to be
        hard linked. In other words: <strong>&lt;img src=&quot;btnSource.gif&quot;&gt;</strong>
        won't work but <strong>&lt;img src=&quot;http://www.yourdomain.com/btnSource.gif&quot;&gt;</strong>
        will work.</font></span></li>
      <li><span style="line-height: 20px"><font face="Arial" size="2">You can use CSS for basic
        fonts and colors but use it sparingly. Many email readers won't support or interpret it
        correctly.</font></span></li>
      <li><span style="line-height: 20px"><font face="Arial" size="2">Use Inline CSS that is not
        linked to files. (Available inside the HTML email message)</font></span></li>
      <li><span style="line-height: 20px"><font face="Arial" size="2">When using CSS, use it below
        the body tag as browser based email applications (like Gmail, Hotmail, Yahoo, etc) strip
        out HTML, HEAD and BODY tags so that they don't interfere with their own web pages. (The
        web page displaying the email)</font></span></li>
      <li><span style="line-height: 20px"><font face="Arial" size="2">JavaScript, ActiveX
        Controls, Flash and embedded movie files will normally not work. The reason they will
        normally not work or not work properly is because most people have antivirus software that
        will block these.</font></span></li>
      <li><span style="line-height: 20px"><font face="Arial" size="2">Background colors and images
        will normally not work with browser based email services like Gmail, Yahoo, Hotmail, etc.
        The reason for this is that they strip out HTML, HEAD and BODY tags from HTML email
        received.</font></span></li>
    </ul>
    <p><span style="line-height: 20px"><font face="Arial" size="2"><strong>Spam Filter Details
    and Guidelines:</strong></font></span><ul>
      <li><span style="line-height: 20px"><font face="Arial" size="2">You will need a good balance
        between images and text else spam filters will flag the email as spam.</font></span></li>
      <li><span style="line-height: 20px"><font face="Arial" size="2">Make sure your HTML code has
        no errors and ensure that your email message contains proper grammar and spelling.
        Spammers are renown for sloppy HTML code and grammar.</font></span></li>
    </ul>
    </td>
  </tr>
</table>
</center></div>


];


$wysicont = qq[<script language="Javascript" src="$webdir/scripts/innovaeditor.js"></script></head>];

$template =~ s/!!controlpanel!!/$tmplc/g;
$template =~ s/<\/head>/$wysicont/gi;
print $template;


}




sub send_email
{

$id = $q->param('id');

$filec = easylist::get_file_contents("$data_dir/$id.emls");  
my @eitems = split (/\n/, $filec);


print qq[<html>

<head>
<title>Easylist Mailer</title>
<style type="text/css">
A {COLOR: #0000FF}
A:visited {COLOR: #0000FF}
A:active {COLOR: #000000}
A:hover {COLOR: #000000}

body
{
background-image:
url("$webdir/fcbg.jpg");
background-repeat: repeat-x;
background-attachment:
fixed
}

</style>
</head>

<body background="$webdir/fcbg.jpg">



<form action="$script_url/mailer.cgi" method="POST" name="searchb">
  <input type="hidden" name="fct" value="start_mail"><input type="hidden" name="id"
  value="$id"><div align="center"><center><table border="0" cellspacing="0" width="750"
  cellpadding="0">
    <tr>
      <td width="750" colspan="2">&nbsp; <br>
      <img src="$webdir/logom.jpg" width="617" height="119"></td>
    </tr>
    <tr>
      <td width="65" height="20"></td>
      <td width="685" align="center"></td>
    </tr>
  </table>
  </center></div><div align="center"><center><table border="0" cellspacing="0" width="750"
  cellpadding="0">
    <tr>
      <td width="447"><img src="$webdir/semail1.gif" width="476" height="32"></td>
    </tr>
  </table>
  </center></div><div align="center"><center><table bgColor="#F0F0F0" border="0"
  cellPadding="3" cellSpacing="1" width="750">
    <tr>
      <td bgColor="#FFFFFF" width="255" background="$webdir/grayback2.jpg"><font
      face="MS Sans Serif" size="1">&nbsp;&nbsp;&nbsp; Email Message to Send: ( <a
      href="$script_url/admin2.cgi?fct=edit_email&amp;id=$id" target="_blank">Edit</a> )</font></td>
      <td bgColor="#FFFFFF" height="35" width="479"><font face="MS Sans Serif" size="1"><strong>$eitems[0]</strong></font></td>
    </tr>
    <tr>
      <td bgColor="#FFFFFF" width="255" background="$webdir/grayback2.jpg"><font
      face="MS Sans Serif" size="1">&nbsp;&nbsp;&nbsp; Number of Emails to send at a time:</font></td>
      <td bgColor="#ffffff" width="479"><font face="MS Sans Serif" size="1"><input type="text"
      name="email_nr" size="4" value="10"></font></td>
    </tr>
    <tr>
      <td bgColor="#FFFFFF" width="255" background="$webdir/grayback2.jpg"><font
      face="MS Sans Serif" size="1">&nbsp;&nbsp;&nbsp; Seconds to wait after each send:</font></td>
      <td bgColor="#ffffff" width="479"><font face="MS Sans Serif" size="1"><input type="text"
      name="secs" size="4" value="1"></font></td>
    </tr>
    <tr>
      <td bgColor="#FFFFFF" width="255" background="$webdir/grayback2.jpg"></td>
      <td bgColor="#ffffff" width="479"><font face="MS Sans Serif" size="1"><input type="submit"
      value="Start Sending" name="B1"> </font></td>
    </tr>
    <tr>
      <td bgColor="#ffffff" width="734" colspan="2"><blockquote>
        <p><font face="Arial" size="2"><strong><font color="#FFFFFF">__</font><br>
        Help:</strong></font></p>
      </blockquote>
      <blockquote>
        <p><span style="line-height: 20px"><font face="MS Sans Serif" size="1"><strong>Number of
        Emails to send at a time: </strong>You will be using your mail server to send the email
        with. Sending large numbers of mail at a time can slow it down and place a lot of load on
        it. Only sending a small number of email addresses at time (per batch) will lesson the
        load placed on the mail server. <font color="#0000A0"><strong>It is strongly recommended
        that you keep this number low. Some hosting companies will dissable your account if you
        put too much load on the mail server. Keep this number low!</strong></font></font></span></p>
      </blockquote>
      <blockquote>
        <p><span style="line-height: 20px"><font face="MS Sans Serif" size="1"><strong>Seconds to
        wait after each send: </strong>This is the number of seconds the script will wait before
        sending each batch of emails. The longer you wait the less load will be placed on the mail
        server.<br>
        </font></span><font face="Arial" size="2" color="#FFFFFF"><strong>__</strong></font></p>
      </blockquote>
      </td>
    </tr>
  </table>
  </center></div>
</form>

<form method="POST" action="$script_url/mailer.cgi">
  <input type="hidden" name="id" value="$id"><input type="hidden" name="fct"
  value="testmail"><div align="center"><center><table border="0" cellspacing="0" width="750"
  cellpadding="0">
    <tr>
      <td width="750"><img src="$webdir/semail2.gif" width="476" height="32"></td>
    </tr>
  </table>
  </center></div><div align="center"><center><table bgColor="#C0C0C0" border="0"
  cellPadding="3" cellSpacing="1" width="750">
    <tr>
      <td bgColor="#FFFFFF" width="255" background="$webdir/grayback2.jpg">&nbsp;&nbsp;&nbsp; <font
      face="MS Sans Serif" size="1">Email Address to send to:</font></td>
      <td bgColor="#FFFFFF" width="479"><input type="text" name="email_test" size="51"></td>
    </tr>
    <tr>
      <td bgColor="#FFFFFF" width="255" background="$webdir/grayback2.jpg">&nbsp;&nbsp;&nbsp; <font
      face="MS Sans Serif" size="1">Is this going to be an HTML email?</font></td>
      <td bgColor="#FFFFFF" width="479"><input type="checkbox" name="html_email" value="Y"></td>
    </tr>
    <tr>
      <td bgColor="#FFFFFF" width="255" background="$webdir/grayback2.jpg"></td>
      <td bgColor="#FFFFFF" width="479"><input type="submit" value="Send Test Email" name="B2"></td>
    </tr>
    <tr>
      <td bgColor="#FFFFFF" width="734" colspan="2"><blockquote>
        <p><font face="Arial" size="2"><strong><font color="#FFFFFF">_</font><br>
        Help:</strong></font></p>
      </blockquote>
      <blockquote>
        <p><font face="MS Sans Serif" size="1"><span style="line-height: 20px">If you want to send
        an email to yourself for a test use the Test Send function above. It will send the email
        message to the email address you specify.</span><br>
        <font color="#FFFFFF">___</font></font></p>
      </blockquote>
      </td>
    </tr>
  </table>
  </center></div>
</form>

<p>&nbsp;</p>
</body>
</html>
];


}




sub del_email
{
$id = $q->param('id');

unlink ("$data_dir/$id.emls");

if (-e "$data_dir/$id.htem") { unlink ("$data_dir/$id.htem"); }

$tmplc = <<END_OF_TMPL;
<table>
  <tr>
    <td vAlign="top" width="1%"><font face="Verdana" size="1"><img src="$webdir/ic_email1.gif"></font></td>
    <td vAlign="top" width="99%"><font face="Arial" color="#000000" size="4"><strong>Email
    Deleted<br>
    </strong></font><a href="$script_url/admin2.cgi"><font face="Arial" size="2">Click here
    to continue</font></a></td>
  </tr>
</table>
<hr size="1" color="#E5E5E5">
END_OF_TMPL

$template =~ s/!!controlpanel!!/$tmplc/g;
print $template;

}






sub save_email_final
{

if ($q->param('ename') eq "") { &p_popup("Please supply a descriptive name for the Email Message."); }
if ($q->param('from_email') eq "") { &p_popup("Please supply a 'from email address' from which the email messages will be sent."); }
if ($q->param('from_name') eq "") { &p_popup("Please supply a 'from name' from which the email messages will be sent."); }
if ($q->param('subject') eq "") {&p_popup("Please supply a subject for the email message."); }
if ($q->param('msg') eq "") { &p_popup("Please supply message text for the email message."); }



$id = $q->param('id');

open (EMM, "> $data_dir/$id.emls");
	print EMM $q->param('ename') . "\n";
	print EMM $q->param('from_email') . "\n";
	print EMM $q->param('from_name') . "\n";
	print EMM $q->param('subject') . "\n";
	print EMM $q->param('msg') . "\n";
close (EMM);


$tmplc = <<END_OF_TMPL;
<table>
  <tr>
    <td vAlign="top" width="1%"><font face="Arial" size="2"><img src="$webdir/ic_email1.gif"></font></td>
    <td vAlign="top" width="99%"><font face="Arial" color="#000000" size="4"><strong>Email
    Saved<br>
    </strong></font><a href="$script_url/admin2.cgi"><font face="Arial" size="2">Click here
    to continue</font></a></td>
  </tr>
</table>
<hr size="1" color="#E5E5E5">
END_OF_TMPL

$template =~ s/!!controlpanel!!/$tmplc/g;
print $template;



}





sub edit_email
{

$id = $q->param('id');

$filec = easylist::get_file_contents("$data_dir/$id.emls");  
my @eitems = split (/\n/, $filec);

$lc = 0;
foreach $e_item (@eitems)
	{
	if ($lc > 3)
		{
		$emsg = $emsg . $e_item . "\n";
		}
	$lc++;
	}



if (-e "$data_dir/$id.htem")
	{

	$emsg =~ s/&/&amp;/gi;
	$emsg =~ s/</&lt;/gi;
	$emsg =~ s/>/&gt;/gi;
	

$dizbox = qq[
  <tr>
    <td bgColor="#FFFFFF" colspan="2">
    <textarea id="txtContent" name="msg" rows="100" cols="50">$emsg</textarea> 
	 <script>
	 		var oEdit1 = new InnovaEditor("oEdit1");
	 		oEdit1.width="100%";
	 		oEdit1.height="650px";
	 		oEdit1.mode="HTML";
	 		oEdit1.REPLACE("txtContent");
	 </script> 
    </td>
  </tr>

];	
	
$wysicont = qq[<script language="Javascript" src="$webdir/scripts/innovaeditor.js"></script>];

$html_email_msg = qq[


<font face="Arial" size="2"><strong>

<p>Notes:</strong></font>

<ul>
  <li><span style="line-height: 20px;"><font face="Arial" size="2">Click the <strong>&lt;&gt;</strong>
    icon in the top menu bar of the Wysiwyg editor to view the source of the page or to copy
    and paste HTML code from a web editor into this web editor.</font></span></li>
  <li><span style="line-height: 20px;"><font face="Arial" size="2">We have gone to great
    lengths to ensure the successful sending of HTML email but note that most email programs
    won't interpret HTML email the same.</font></span></li>
  <li><span style="line-height: 20px;"><font face="Arial" size="2">The most reliable way to
    send email to subscribers to ensure that they are successfully receiving it is to use
    plain text email.</font></span></li>
</ul>

<p><span style="line-height: 20px;"><font face="Arial" size="2"><strong>HTML Design Email
Guidelines:</strong></font></span>

<ul>
  <li><span style="line-height: 20px;"><font face="Arial" size="2">Send yourself a test
    message to get a preview of how the HTML email will arrive at subscribers. This can be
    done from the 'Send Email' tab.</font></span></li>
  <li><span style="line-height: 20px;"><font face="Arial" size="2">It is very important that
    you keep your HTML email simple due to Email readers not interpreting all HTML email
    equally. It would be necessary that you test the HTML message with Outlook 2003, Outlook
    2000, Outlook Express, Eudora, Mozilla Thunderbird, AOL, Yahoo Mail, Google's Gmail,
    Hotmail, etc.</font></span></li>
  <li><span style="line-height: 20px;"><font face="Arial" size="2">All images used need to be
    hard linked. In other words: <strong>&lt;img src=&quot;btnSource.gif&quot;&gt;</strong>
    won't work but <strong>&lt;img src=&quot;http://www.yourdomain.com/btnSource.gif&quot;&gt;</strong>
    will work.</font></span></li>
  <li><span style="line-height: 20px;"><font face="Arial" size="2">You can use CSS for basic
    fonts and colors but use it sparingly. Many email readers won't support or interpret it
    correctly.</font></span></li>
  <li><span style="line-height: 20px;"><font face="Arial" size="2">Use Inline CSS that is not
    linked to files. (Available inside the HTML email message)</font></span></li>
  <li><span style="line-height: 20px;"><font face="Arial" size="2">When using CSS, use it
    below the body tag as browser based email applications (like Gmail, Hotmail, Yahoo, etc)
    strip out HTML, HEAD and BODY tags so that they don't interfere with their own web pages.
    (The web page displaying the email)</font></span></li>
  <li><span style="line-height: 20px;"><font face="Arial" size="2">JavaScript, ActiveX
    Controls, Flash and embedded movie files will normally not work. The reason they will
    normally not work or not work properly is because most people have antivirus software that
    will block these.</font></span></li>
  <li><span style="line-height: 20px;"><font face="Arial" size="2">Background colors and
    images will normally not work with browser based email services like Gmail, Yahoo,
    Hotmail, etc. The reason for this is that they strip out HTML, HEAD and BODY tags from
    HTML email received.</font></span></li>
</ul>

<p><span style="line-height: 20px;"><font face="Arial" size="2"><strong>Spam Filter
Details and Guidelines:</strong></font></span>

<ul>
  <li><span style="line-height: 20px;"><font face="Arial" size="2">You will need a good
    balance between images and text else spam filters will flag the email as spam.</font></span></li>
  <li><span style="line-height: 20px;"><font face="Arial" size="2">Make sure your HTML code
    has no errors and ensure that your email message contains proper grammar and spelling.
    Spammers are renown for sloppy HTML code and grammar.</font></span></li>
</ul>

];

	}
	else
	{
$dizbox = qq[
    <tr>
      <td bgColor="#FFFFFF" width="24%" height="347" valign="top"><font face="Arial" size="2">Message:</font></td>
      <td bgColor="#FFFFFF" width="58%" height="347"><font face="Arial" size="2">
      <textarea rows="17" name="msg" cols="59">$emsg</textarea>
      </font></td>
    </tr>
	];
	}


$tmplc = qq[

<table>
  <tr>
    <td vAlign="top" width="1%"><font face="Verdana" size="1"><img src="$webdir/ic_email1.gif"></font></td>
    <td vAlign="top" width="99%"><font face="Arial" color="#000000" size="4"><strong>Edit
    Email</strong></font></td>
  </tr>
</table>

<hr size="1" color="#E5E5E5">

<form method="POST" action="$script_url/admin2.cgi">
  <input type="hidden" name="fct" value="save_email_final"><input type="hidden" name="id"
  value="$id"><table bgColor="#C0C0C0" border="0" cellPadding="6" cellSpacing="1"
  width="100%" height="568">
    <tr>
      <td bgColor="#FFE135" colSpan="2" height="30" width="100%" background="$webdir/bar.gif"><font
      face="Arial" size="2"><strong>Email Message</strong></font></td>
    </tr>
    <tr>
      <td bgColor="#FFFFFF" width="24%" height="41"><font face="Arial" size="2">Description of
      this message:</font></td>
      <td bgColor="#FFFFFF" width="58%" height="41"><font face="Arial" size="2"><input
      type="text" name="ename" size="45" value="$eitems[0]"> <br>
      (Enter a descriptive name for this email message)</font></td>
    </tr>
    <tr>
      <td bgColor="#FFFFFF" width="24%" height="25"><font face="Arial" size="2">From Email
      Address:</font></td>
      <td bgColor="#FFFFFF" width="58%" height="25"><font face="Arial" size="2"><input
      type="text" name="from_email" size="45" value="$eitems[1]"> </font></td>
    </tr>
    <tr>
      <td bgColor="#FFFFFF" width="24%" height="25"><font face="Arial" size="2">From Name:</font></td>
      <td bgColor="#FFFFFF" width="58%" height="25"><font face="Arial" size="2"><input
      type="text" name="from_name" size="45" value="$eitems[2]"> </font></td>
    </tr>
    <tr>
      <td bgColor="#FFFFFF" width="24%" height="25"><font face="Arial" size="2">Email Subject:</font></td>
      <td bgColor="#FFFFFF" width="58%" height="25"><font face="Arial" size="2"><input
      type="text" name="subject" size="54" value="$eitems[3]"></font></td>
    </tr>

$dizbox

    <tr>
      <td bgColor="#FFFFFF" width="24%" height="27"></td>
      <td bgColor="#FFFFFF" width="58%" height="27"><input type="submit"
      value="Save Email Message" name="B1"></td>
    </tr>
  </table>
</form>

$html_email_msg


];


$template =~ s/<\/head>/$wysicont<\/head>/gi;
$template =~ s/!!controlpanel!!/$tmplc/g;
print $template;

}



sub p_popup
{

my ($problem_text) = @_;

$tmplc = <<END_OF_PR;

<table border="0" cellpadding="0" cellspacing="0" width="100%">
  <tr>
    <td width="6%" valign="top"><img src="$webdir/ic_alert.gif"></td>
    <td width="94%" valign="top"><font face="Arial" size="4" color="#000000"><strong>Problem</strong></font><font
    face="Verdana" size="1" color="#000000"><br>
    </font><font face="Arial" size="2">$problem_text</font></td>
  </tr>
</table>
<p><font face="Arial" size="2"><strong>Use the back button of your browser to go back.</strong></font></p>
<hr noshade size="1" color="#EBEBEB">

END_OF_PR

$template =~ s/!!controlpanel!!/$tmplc/g;

print $template;

exit;

}





sub add_email_final
{

### CHECK FOR ERRORS

if ($q->param('ename') eq "") { &p_popup("Please supply a descriptive name for the Email Message."); }
if ($q->param('from_email') eq "") { &p_popup("Please supply a 'from email address' from which the email messages will be sent."); }
if ($q->param('from_name') eq "") { &p_popup("Please supply a 'from name' from which the email messages will be sent."); }
if ($q->param('subject') eq "") {&p_popup("Please supply a subject for the email message."); }
if ($q->param('msg') eq "") { &p_popup("Please supply message text for the email message."); }

$emcounter = easylist::get_file_contents("$data_dir/emcnt.dat");  
$emcounter++;

open (EMC, "> $data_dir/emcnt.dat");
	print EMC $emcounter . "\n";
close (EMC);

########

if (length($emcounter) == 1) {$emcounter = "000000000000" . $emcounter;}
if (length($emcounter) == 2) {$emcounter = "00000000000" . $emcounter;}
if (length($emcounter) == 3) {$emcounter = "0000000000" . $emcounter;}
if (length($emcounter) == 4) {$emcounter = "000000000" . $emcounter;}
if (length($emcounter) == 5) {$emcounter = "00000000" . $emcounter;}
if (length($emcounter) == 6) {$emcounter = "0000000" . $emcounter;}
if (length($emcounter) == 7) {$emcounter = "000000" . $emcounter;}
if (length($emcounter) == 8) {$emcounter = "00000" . $emcounter;}
if (length($emcounter) == 9) {$emcounter = "0000" . $emcounter;}
if (length($emcounter) == 10){$emcounter = "000" . $emcounter;}
if (length($emcounter) == 11){$emcounter = "00" . $emcounter;}
if (length($emcounter) == 12){$emcounter = "0" . $emcounter;}	
 


$htmlmsg = $q->param('msg');

if ($q->param('htmlemail') eq "true")
	{
	open (HTMLEM, "> $data_dir/$emcounter.htem");
	print HTMLEM $htmlmsg;
	close (HTMLEM);
	}

open (EMM, "> $data_dir/$emcounter.emls");
	print EMM $q->param('ename') . "\n";
	print EMM $q->param('from_email') . "\n";
	print EMM $q->param('from_name') . "\n";
	print EMM $q->param('subject') . "\n";
	print EMM $htmlmsg . "\n";
close (EMM);


$tmplc = <<END_OF_TMPL;
<table>
  <tr>
    <td vAlign="top" width="1%"><font face="Arial" size="2"><img src="$webdir/ic_email1.gif"></font></td>
    <td vAlign="top" width="99%"><font face="Arial" color="#000000" size="4"><strong>Email
    Saved<br>
    </strong></font><a href="$script_url/admin2.cgi"><font face="Arial" size="2">Click here
    to continue</font></a></td>
  </tr>
</table>
<hr size="1" color="#E5E5E5">
END_OF_TMPL

$template =~ s/!!controlpanel!!/$tmplc/g;
print $template;


}





sub add_email
{

$tmplc = qq[

<table>
  <tr>
    <td vAlign="top" width="1%"><font face="Verdana" size="1"><img src="$webdir/ic_email1.gif"></font></td>
    <td vAlign="top" width="99%"><font face="Arial" color="#000000" size="4"><strong>Compose
    Email<br>
    </strong></font><font face="Arial" size="2">Type your email message below and choose
    'Create Email Message'. You will be able to send out the email message to subscribers
    after the it has been composed/created.</font></td>
  </tr>
</table>

<hr size="1" color="#E5E5E5">

<form method="POST" action="$script_url/admin2.cgi">
  <input type="hidden" name="fct" value="add_email_final"><table bgColor="#C0C0C0"
  border="0" cellPadding="3" cellSpacing="1" width="100%">
    <tr>
      <td bgColor="#FFE135" colSpan="2" height="30" width="100%" background="$webdir/bar.gif"><font
      face="Arial" size="2"><strong>Email Messages</strong></font></td>
    </tr>
    <tr>
      <td bgColor="#FFFFFF" width="21%" height="30"><font face="Arial" size="2">Description of 
      this message:</font></td>
      <td bgColor="#FFFFFF" width="61%" height="30"><font face="Arial" size="2"><input
      type="text" name="ename" size="45"><br>
      (Enter a descriptive name for this email message)</font></td>
    </tr>
    <tr>
      <td bgColor="#FFFFFF" width="21%" height="30"><font face="Arial" size="2">From Email 
      Address:</font></td>
      <td bgColor="#FFFFFF" width="61%" height="30"><font face="Arial" size="2"><input
      type="text" name="from_email" size="45"> </font></td>
    </tr>
    <tr>
      <td bgColor="#FFFFFF" width="21%" height="30"><font face="Arial" size="2">From Name:</font></td>
      <td bgColor="#FFFFFF" width="61%" height="30"><font face="Arial" size="2"><input
      type="text" name="from_name" size="45"> </font></td>
    </tr>
    <tr>
      <td bgColor="#FFFFFF" width="21%" height="30"><font face="Arial" size="2">Email Subject:</font></td>
      <td bgColor="#FFFFFF" width="61%" height="30"><font face="Arial" size="2"><input
      type="text" name="subject" size="54"></font></td>
    </tr>
    <tr>
      <td bgColor="#FFFFFF" width="21%" height="30" valign="top"><font face="Arial" size="2">Email 
      Message:</font></td>
      <td bgColor="#FFFFFF" width="61%" height="30"><font face="Arial" size="2"><textarea
      rows="17" name="msg" cols="59"></textarea></font></td>
    </tr>
    <tr>
      <td bgColor="#FFFFFF" width="21%" height="30"></td>
      <td bgColor="#FFFFFF" width="61%" height="30"><input type="submit"
      value="Create Email Message" name="B1"></td>
    </tr>
  </table>
</form>


];

$template =~ s/!!controlpanel!!/$tmplc/g;
print $template;

}












sub email_addresses_to_screen
{

if ($mysql_hostname eq ""){$dsn = "DBI:mysql:$db_name";}else{$dsn = "DBI:mysql:$db_name:$mysql_hostname:$mysql_port";}
$dbh = DBI->connect($dsn, $db_username, $db_password);
if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; } 

$filter = $q->param('filter');
if ($filter eq "true")
	{
	$fcrit = $q->param('fcrit');
   if ($fcrit eq "Greater") { $lrchr = ">"; } else { $lrchr = "<"; }
	$amount = $q->param('amount');
	$sql = "SELECT email FROM ppc_users WHERE balance $lrchr '$amount'";
	}
	else
	{
	$sql = "SELECT email FROM ppc_users";
	}
$sth = $dbh->prepare($sql);
$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror \n From: $sql";}

while ( @row = $sth->fetchrow() ) 
	{
	print $row[0] . "<BR>";
	}

$sth->finish;
$dbh->disconnect; 


}





sub get_mail_details
{

if ($q->param('filter') eq "true")
	{
	$filter_true = qq[<input type="hidden" name="filter" value="true">];
	
	$fcrit = $q->param('fcrit');
	$filter_crit = qq[<input type="hidden" name="fcrit" value="$fcrit">];
	
	$amount = $q->param('amount');
	$filter_crit2 = qq[<input type="hidden" name="amount" value="$amount">];
	}

$email_nr = $q->param('email_nr');

print qq[

<html>
<head>
<title>Send Email</title>
</head>
<body>
<table>
  <tr>
    <td vAlign="top" width="1%"><font face="Verdana" size="1"><img
    src="$webdir/ppc_iuser.gif"></font></td>
    <td vAlign="top" width="99%"><font face="Arial" color="#000000" size="4"><strong>Compose
    Email</strong></font></td>
  </tr>
</table>
<hr size="1" color="#E5E5E5">
<form action="$admin_url/ppc_mailer.cgi" method="POST">
  <input type="hidden" name="fct" value="send_aemail">
  <input type="hidden" name="email_nr" value="$email_nr">
  $filter_true
  $filter_crit
  $filter_crit2
  <table bgColor="#c0c0c0" border="0" cellPadding="3" cellSpacing="1" width="100%">
    <tr>
      <td bgColor="#ffe135" colSpan="2" height="30" width="100%"><font face="Verdana" size="1"><strong>Compose
      the Email you will be sending to Advertisers</strong></font></td>
    </tr>
    <tr>
      <td bgColor="#ffffff" width="28%"><font face="Verdana" size="1">From Email Address:</font></td>
      <td bgColor="#ffffff" width="72%"><input type="text" name="from_email" size="38"></td>
    </tr>
    <tr>
      <td bgColor="#ffffff" width="28%"><font face="Verdana" size="1">From Name: </font></td>
      <td bgColor="#ffffff" width="72%"><input type="text" name="from_name" size="38"></td>
    </tr>
    <tr>
      <td bgColor="#ffffff" width="28%"><font face="Verdana" size="1">Subject:</font></td>
      <td bgColor="#ffffff" width="72%"><input type="text" name="subject" size="66"></td>
    </tr>
    <tr>
      <td bgColor="#FFFFFF" width="28%" valign="top"><font face="Verdana" size="1">Message:</font></td>
      <td bgColor="#ffffff" width="72%"><textarea rows="14" name="message" cols="61"></textarea></td>
    </tr>
    <tr>
      <td bgColor="#ffffff" width="28%"></td>
      <td bgColor="#ffffff" width="72%"><input type="submit" value="Start Sending" name="B1"> </td>
    </tr>
  </table>
</form>

<table bgColor="#c0c0c0" border="0" cellPadding="3" cellSpacing="1" width="100%">
  <tr>
    <td bgColor="#ffe135" colSpan="2" height="30" width="100%"><font face="Verdana" size="1"><strong>Variables
    Available In Email<br>
    </strong>Use the variables (words) below inside the email message.</font></td>
  </tr>
  <tr>
    <td bgColor="#ffffff" width="15%"><font face="Verdana" size="1">!!username!!</font></td>
    <td bgColor="#ffffff" width="85%"><font face="Verdana" size="1">Replaced by the user name
    of the advertiser.</font></td>
  </tr>
  <tr>
    <td bgColor="#ffffff" width="15%"><font face="Verdana" size="1">!!password!!</font></td>
    <td bgColor="#ffffff" width="85%"><font face="Verdana" size="1">Replaced by the password
    of the advertiser.</font></td>
  </tr>
  <tr>
    <td bgColor="#ffffff" width="15%"><font face="Verdana" size="1">!!firstname!!</font></td>
    <td bgColor="#ffffff" width="85%"><font face="Verdana" size="1">Replaced by the first name
    of the advertiser.</font></td>
  </tr>
  <tr>
    <td bgColor="#ffffff" width="15%"><font face="Verdana" size="1">!!surname!!</font></td>
    <td bgColor="#ffffff" width="85%"><font face="Verdana" size="1">Replaced by the surname of
    the advertiser.</font></td>
  </tr>
  <tr>
    <td bgColor="#ffffff" width="15%"><font face="Verdana" size="1">!!email!!</font></td>
    <td bgColor="#ffffff" width="85%"><font face="Verdana" size="1">Replaced by the email
    address of the advertiser.</font></td>
  </tr>
  <tr>
    <td bgColor="#ffffff" width="15%"><font face="Verdana" size="1">!!balance!!</font></td>
    <td bgColor="#ffffff" width="85%"><font face="Verdana" size="1">Replaced by the account balance of the advertiser.</font></td>
  </tr>  
</table>


</body>
</html>

];



}





sub start
{


$emtable = qq[

<table bgColor="#E5E5E5" border="0" cellPadding="3" cellSpacing="1" width="100%">
  <tr>
    <td bgColor="#FFE135" colSpan="5" height="30" width="100%" background="$webdir/bar.gif"><strong><font
    face="Arial" size="2">Email Messages</font></strong></td>
  </tr>
  <tr>
    <td bgColor="#F7F7F7" height="30" width="28%"><strong><font face="Arial" size="2">Description
    of Composed Email</font></strong></td>
    <td bgColor="#F7F7F7" height="30" width="6%" align="center"><font face="Arial" size="2"><strong>Type</strong></font></td>
    <td bgColor="#F7F7F7" height="30" width="17%" align="center"><strong><font face="Arial"
    size="2">Click to Edit</font></strong></td>
    <td bgColor="#F7F7F7" height="30" width="16%" align="center"><strong><font face="Arial"
    size="2">Click to Delete</font></strong></td>
    <td bgColor="#F7F7F7" height="30" width="17%" align="center"><strong><font face="Arial"
    size="2">Click to Send Email</font></strong></td>
  </tr>
];


##########

opendir(DIR,"$data_dir");
@files = readdir(DIR);
@files = reverse sort @files; 

foreach $filename (@files)
	{
	if (substr($filename, length($filename) - 5, 5) eq ".emls")
		{
		
			$hfile = substr($filename, 0, length($filename) - 5);
			
		   if (-e "$data_dir/$hfile.htem")
		   	{
		   	$etype = "HTML";
		   	}
		   	else
		   	{
		   	$etype = "Plain";
		   	}
		
			$emfile = easylist::get_file_contents("$data_dir/$filename");
			my @flines = split (/\n/, $emfile);
			
			$fmdiz = $flines[0];
			$fileid = substr($filename, 0, length($filename) - 5);
			
			$emtable = $emtable . qq[
  <tr>
    <td bgColor="#FFFFFF" width="40%" height="30"><font face="Arial" size="2">$fmdiz</font></td>
    <td bgColor="#FFFFFF" width="10%" align="center" height="30"><font face="Arial" size="2">$etype</font></td>
    <td bgColor="#FFFFFF" width="10%" align="center" height="30"><font face="Arial" size="2"><a href="$script_url/admin2.cgi?fct=edit_email&amp;id=$fileid">Edit</a></font></td>
    <td bgColor="#FFFFFF" width="10%" align="center" height="30"><font face="Arial" size="2"><a href="$script_url/admin2.cgi?fct=del_email&amp;id=$fileid">Delete</a></font></td>
    <td bgColor="#FFFFFF" width="20%" align="center" height="30"><font face="Arial" size="2"><a href="$script_url/admin2.cgi?fct=send_email&amp;id=$fileid" onClick="popup('$script_url/admin2.cgi?fct=send_email&amp;id=$fileid',800,600);return false;">Send Email</a></font></td>
  </tr>

];
	    
	    $emailitems = "true";
		}
	}


if ($emailitems ne "true")
	{
$emtable = $emtable . qq[
  <tr>
    <td bgColor="#FFFFFF" width="82%" height="30" colspan="5"><font face="Arial" size="2">There
    are currently no Email Messages. Please click the 'Create New Email Message' button to
    create a new email message that can be sent to the subscribers of your mailing list.</font></td>
  </tr>
];	
	}

$emtable = $emtable . "</table>";


$tmplc = qq[

<table>
  <tr>
    <td vAlign="top" width="1%"><font face="Verdana" size="1"><img src="$webdir/ic_email1.gif"></font></td>
    <td vAlign="top" width="99%"><strong><strong><font face="Arial" color="#000000" size="4">Compose
    Email &amp; Send Email to Subscribers<br>
    </font></strong></strong><font face="Arial" size="2" color="#000000">In this section you
    can compose email messages and send the messages to subscribers.</font></td>
  </tr>
</table>

<hr size="1" color="#E5E5E5">

<form method="POST" action="$script_url/admin2.cgi">
  <input type="hidden" name="fct" value="create_email_type"><p>$emtable </p>
  <p>&nbsp;</p>
  <div align="center"><center><table border="0" cellpadding="4" cellspacing="0" width="100%">
    <tr>
      <td width="1%"><input type="submit" value="   Create New Email Message    " name="B1"></td>
      <td width="75%"><strong><font face="Arial" size="2"><input type="radio" value="plain"
      name="email_type" checked>Plain <input type="radio" value="HTML" name="email_type">HTML</font></strong></td>
    </tr>
  </table>
  </center></div><p><font face="Arial" size="2">Press the 'Create New Email Message' button
  to create a new email message to send to subscribers of the mailing list.</font></p>
</form>
];


$template =~ s/!!controlpanel!!/$tmplc/g;
print $template;

}




######################################################################

sub get_setup
{

$exists = (-e "config.cgi");
if ($exists > 0)
	{
	
	open (STP, "config.cgi");
		while (defined($line=<STP>))
			{
			if ($line =~ m/#/g)
				{
				$r = pos($line);
				$line = substr($line, 0, $r - 1);
				}
				
				$line =~ s/\n//g;
	
if ($line =~ /^WEBDIR/){$webdir = &get_setup_line($line, WEBDIR);}
if ($line =~ /^DATA_DIR/){$data_dir = &get_setup_line($line, DATA_DIR);}
if ($line =~ /^SCRIPT_URL/){$script_url = &get_setup_line($line, SCRIPT_URL);}
if ($line =~ /^USERNAME/){$username = &get_setup_line($line, USERNAME);}
if ($line =~ /^PASSWORD/){$password = &get_setup_line($line, PASSWORD);}
if ($line =~ /^EMLLOC/){$emmloc = &get_setup_line($line, EMLLOC);}

			}
	close (STP);

if (length($emmloc) < 4) { 

$tmpl3 = easylist::get_file_contents("$data_dir/emcnt2.dat");
@alltitems = split (/,/, $tmpl3);
$cnc = 1;
foreach $tmitem(@alltitems)
	{
	$cnc++;
	if ($cnc == 5){$cnc = 1;}
	$tmitem = ($tmitem - $cnc);
	$rptit = $rptit . chr($tmitem);
	}
$version = $version . "<BR>".$rptit;
}

	
	}
}




sub get_setup_line
{
my ($setup_line, $setup_var) = @_;
$crit = "\"";
$setup_line =~ m/$crit/g;
$r1 = pos($setup_line);
$setup_line =~ m/$crit/g;
$r2 = pos($setup_line);
$setup_line = substr($setup_line, $r1, ($r2 - $r1 - 1));
$return_val = $setup_line;
return ($return_val);
}

#### END CONFIGURATION ########################################################

